package org.zeroturnaround.javarebel.integration.weblogic;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>weblogic.servlet.internal.WebAppModule</code>.
 * 
 * @author Rein Raudjärv
 */
public class WebAppModuleCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    try {
      CtMethod m = ctClass.getDeclaredMethod("setClassFinder");
      m.insertAfter(
          "{ " + 
          "  org.zeroturnaround.javarebel.IntegrationFactory.getInstance()" +
          "    .reinitializeClassLoader($0.webClassLoader);" +
          "}");
    }
    catch (NotFoundException e) {
      // skip
    }
  }
}
